#pragma once

#include "flexpage.h"
#include "page_owner.h"
#include "pages.h"

#include <map>
#include <mutex>

/* Collection types. */

typedef std::map<offset_t, Flexpage *> _AccessMap;
typedef std::pair<offset_t, Flexpage *> _AccessMapEntry;

/* A mapping from file positions to flexpages. */

class AccessMap
{
protected:
    _AccessMap _flexpages;
    std::mutex _lock;

public:
    Flexpage *find(offset_t position);

    void insert(Flexpage *flexpage);

    bool remove(PageOwner *owner, Flexpage *flexpage);

    void purge(PageOwner *owner, PageCollection *pages);

    void flush_all(offset_t start, offset_t size, PageOwner *owner, PageCollection *pages);
};

// vim: tabstop=4 expandtab shiftwidth=4
